'''
    This script counts instances of each language tags found in type 1 posts
'''

import csv, array

STATS = 'stats file (txt)'
DATA = ['first filtered dataset (csv)', 'second filtered dataset (csv)', '...']

# words to match
LANGUAGES = ['javascript', 'html', 'css', 'sql', 'java', 'bash', 'shell', 'python', 'c#', 'php', 'c++', 'c', 'typescript', 'ruby', 'swift', 'assembly', 'go', 'objective-c', 'vb.net', 'r', 'matlab', 'vba', 'kotlin', 'scala', 'groovy', 'perl']

# create header for the csv
header = ['javascript', 'html', 'css', 'sql', 'java', 'bash', 'shell', 'python', 'c#', 'php', 'c++', 'c', 'typescript', 'ruby', 'swift', 'assembly', 'go', 'objective-c', 'vb.net', 'r', 'matlab', 'vba', 'kotlin', 'scala', 'groovy', 'perl']
header.insert(0, 'file')
header.append('total')


open(STATS, 'w').close()
with open(STATS, 'a') as outFile:
    writer = csv.writer(outFile, delimiter=';')
    writer.writerow(header) 
    total = 0
    for dataSet in DATA:
        # each element is the number of instances of that language, indexs are matching with LANGUAGES
        langOccurences = [0] * 26
        with open(dataSet, 'r') as file:
            reader = csv.reader(file, delimiter=';')
            next(reader) # skip header
            found = 0
            # tags -> row[1], seprator -> sapce
            for row in reader: # for each file line (after headers)
                    for word in row[1].split(): # for each word in the 'tags' field
                        if word in LANGUAGES: # check if that word is in 'LANGUAGES'
                            langOccurences[LANGUAGES.index(word)] += 1
        
        newRow = [dataSet]
        total = 0
        for value in langOccurences:
            newRow.append(value)
            total += value
        newRow.append(total)
        writer.writerow(newRow)

